<?php
interface ITransportowy
{
	public function getPredkosc();
	public function getLiczbaMiejsc();
	public function getNazwa();
}

interface ILatajacy
{
	public function getPulap();
}

abstract class CPojazd 
{
	protected $nazwa;
	
	public function __construct( $nazwa )
	{
		$this->nazwa=$nazwa;
	}
	final public function getNazwa()
	{
		return $this->nazwa;
	}
	protected abstract function rejestracjaKursu();
}

final class CBus extends CPojazd implements iTransportowy
{
	function __construct( $nazwa )
	{
		parent::__construct( $nazwa );
	}
	
	function rejestracjaKursu($x=10)
	{
		print("Zapisuje dane kursu do bazy danych<br>");
	}
	
	function getPredkosc()
	{
		return "140km/h";
		//print("Max. predkosc: 140km/h<br>");
	}

	function getLiczbaMiejsc()
	{
		return 14;
		//print("Liczba miejsc: 14<br>");
	}
}

class CMiasto
{
	private $nazwa;
	public function __construct( $nazwa ) { $this->nazwa=$nazwa; }
	public function setNazwa( $nazwa ) { $this->nazwa=$nazwa; }
	public function getNazwa() { return $this->nazwa; }
}

class CAirbus implements ILatajacy
{
	public function getPulap() { return 1200; }
}

class CFirmaTransportowa
{
	public function przewiez( ITransportowy $czym, CMiasto $skad, CMiasto $dokad )
	{
		print( "Informacje o kursie:<br>" );
		print( "Pojazd: {$czym->getNazwa()}<br>" );
		print( "Kurs: {$skad->getNazwa()} - {$dokad->getNazwa()}" );
	}
}
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>interfejsy</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<style type="text/css">
td,th,body { font-family:Verdana, Arial, Helvetica, sans-serif; font-size:10pt; }
</style>
</head>

<body>

<?php
$f=new CFirmaTransportowa();
$f->przewiez( new CBus( "Volvo" ), new CMiasto( "Wrocław" ), new CMiasto( "Warszawa" ) );
//$f->przewiez( new CAirbus( "Volvo" ), "Wrocław", "Warszawa" );
?>

</body>
</html>